﻿<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>PM-journal</title>
  <link rel="stylesheet" href="https://stackedit.io/style.css" />
</head>

<body class="stackedit">
  <div class="stackedit__left">
    <div class="stackedit__toc">
      
<ul>
<li><a href="#recruitment-exercise">Recruitment Exercise</a>
<ul>
<li></li>
</ul>
</li>
<li><a href="#development-journal">Development journal</a>
<ul>
<li><a href="#section">09/12/2019</a>
<ul>
<li>
<ul>
<li></li>
</ul>
</li>
</ul>
</li>
<li><a href="#section-1">10/09/2019</a></li>
<li><a href="#section-2">11/09/2019</a></li>
<li><a href="#section-3">12/09/2019</a></li>
<li><a href="#section-4">13/09/2019</a></li>
<li><a href="#section-5">14/09/2019</a></li>
<li><a href="#section-6">15/09/2019</a></li>
</ul>
</li>
</ul>

    </div>
  </div>
  <div class="stackedit__right">
    <div class="stackedit__html">
      <h1 id="recruitment-exercise">Recruitment Exercise</h1>
<p>This a development journal for a recruitment exercise.</p>
<p>The API can’t be used in production at the moment. To be used in production there are modifications to implement:</p>
<ul>
<li>Authentication (using flask-login for instance)</li>
<li>Database migration</li>
<li>External file storage (such as S3)</li>
<li>A delete route</li>
<li>Tests to insure the database and stored files integrity</li>
</ul>
<h3 id="twelve-factor-app-checklist"><a href="http://12factor.net">Twelve-factor app</a> checklist</h3>

<table>
<thead>
<tr>
<th>✓</th>
<th>Factors</th>
<th align="center">Status</th>
<th>Remarks</th>
</tr>
</thead>
<tbody>
<tr>
<td>1</td>
<td>CodeBase</td>
<td align="center">✓</td>
<td></td>
</tr>
<tr>
<td>2</td>
<td>Dependencies(Explicitly declare and isolate dependencies)</td>
<td align="center">✓</td>
<td></td>
</tr>
<tr>
<td>3</td>
<td>Config(Store config in the environment)</td>
<td align="center">✓</td>
<td></td>
</tr>
<tr>
<td>4</td>
<td>Backing services(Treat backing services as attached resources)</td>
<td align="center">✓</td>
<td></td>
</tr>
<tr>
<td>5</td>
<td>Build, release, run(Strictly separate build and run stages)</td>
<td align="center">✓</td>
<td></td>
</tr>
<tr>
<td>6</td>
<td>Processes(Execute the app as one or more stateless processes)</td>
<td align="center">✓</td>
<td></td>
</tr>
<tr>
<td>7</td>
<td>Port binding(Export services via port binding)</td>
<td align="center">✓</td>
<td></td>
</tr>
<tr>
<td>8</td>
<td>Concurrency(Scale out via the process model)</td>
<td align="center">✗</td>
<td>The API is deployed via Flask blueprints but can’t ensure a proper scalability</td>
</tr>
<tr>
<td>9</td>
<td>Disposability(Maximize robustness with fast startup and graceful shutdown)</td>
<td align="center">-</td>
<td>We don’t ensure that in-flight requests are finished before exiting when SIGTERM signal is received.</td>
</tr>
<tr>
<td>10</td>
<td>Dev/prod parity(Keep development, staging, and production as similar as possible)</td>
<td align="center">-</td>
<td></td>
</tr>
<tr>
<td>11</td>
<td>Logs(Treat logs as event streams)</td>
<td align="center">-</td>
<td>There is not a lot logging (we used Flask logging, and thus python logging library).</td>
</tr>
<tr>
<td>12</td>
<td>Admin processes(Run admin/management tasks as one-off processes)</td>
<td align="center">✗</td>
<td>We did implement some basic function as cli commands, such as recreating the DB or seeding it with some hard-stored images. But there is no proper admin utility commands (such as manually adding an image or proper database management)</td>
</tr>
</tbody>
</table><h1 id="development-journal">Development journal</h1>
<h2 id="section">09/12/2019</h2>
<p>We have to develop a small python RESTful api about image management.<br>
Here are the specifications of the exercise:</p>
<ul>
<li>12factor compliant</li>
<li>docker container</li>
<li>Unitary test</li>
<li>Git</li>
</ul>
<p>The API should at least allows to:</p>
<ul>
<li>Send an image</li>
<li>Extract the metadata from an image</li>
<li>Retrieve similar image from input<br>
To be RESTful compliant, we will add some basic functionalities:</li>
<li>Remove an image</li>
<li>Retrieve an image</li>
</ul>
<p>For the similarity functionality we may think of several approaches:</p>
<ol>
<li>We can use a fully trained DeepRanking neural network to retrieve the most similar images</li>
<li>We can use a pretrained CNN to extract global categories and convert the weights of the last layer to compute L1 or L2 norm. The image which give the smallest norm should be the most similar.</li>
<li>Only use feature extractor from openCV or scikit-image</li>
</ol>
<p>The DeepRanking approach should give the best results but it seems there is no pre-trained model available. This needs also to be ponderated with the fact that it should be slower than a classical CNN.<br>
Using a pre-trained image classification CNN should give less accurate results (as it will only extract a global classification label) but the computing time should also be reduced (with a lightweight model like MobileNetV2 for example).</p>
<h5 id="libraries">Libraries</h5>
<p>Here are the libraries we planned to use during the developpment:</p>
<ul>
<li>Flask/flask-restful: lightweight and easy to implement</li>
<li>Pytest: for unit and functional testing</li>
<li>SQLAlchemy: ORM for database management</li>
<li>Postgres: database backbone</li>
<li>Keras/TF: Neural Networks</li>
<li>Numpy/Scipy: Array manipulation and linear algebra</li>
<li>scikit-image/scikit-learn</li>
</ul>
<p>We will use the flask framework as the backbone of the API.<br>
The Pytest libraries will be used for functional and unitary testing.<br>
Numpy/scipy will be used for arrays manipulation and linear algebra. Depending on the approach for the similarity functionality we will be using OpenCV/scikit-image or keras with the Tensorflow backend.</p>
<p>The images will be stored as binary data in the database. It should be more efficient to write it to a separate storage but as this will be a small app that won’t be a problem.</p>
<h2 id="section-1">10/09/2019</h2>
<p>We have set up the basic backbone of the API using Flask and SQLAlchemy with Postgres database.<br>
We define the basic routes of the API:</p>

<table>
<thead>
<tr>
<th>Endpoint</th>
<th>HTTP</th>
<th>CRUD</th>
<th>Function</th>
</tr>
</thead>
<tbody>
<tr>
<td>/images/:id</td>
<td>GET</td>
<td>READ</td>
<td>Get a single image</td>
</tr>
<tr>
<td>/images</td>
<td>GET</td>
<td>READ</td>
<td>Get a list of all images in db</td>
</tr>
<tr>
<td>/images</td>
<td>POST</td>
<td>CREATE</td>
<td>Add an image</td>
</tr>
<tr>
<td>/images/:id/similar</td>
<td>GET</td>
<td>READ</td>
<td>Get the most similar image</td>
</tr>
<tr>
<td>/images/:id/metadata</td>
<td>GET</td>
<td>READ</td>
<td>Get the image’s metadata</td>
</tr>
</tbody>
</table><p>Following test-driven pattern, for each routes and functionalities we will:</p>
<ol>
<li>write a test</li>
<li>run the test, to ensure it fails</li>
<li>write just enough code to get the test to pass</li>
<li><strong>refactor</strong> (if necessary)</li>
</ol>
<p>We have spent some time figuring out how to receive image via POST method and how to implement the test in the flask framework.<br>
Now this is resolved, we will write the remaining basic routes. Once these will be implemented we will begin to test the implementation of the neural network similarity finder.</p>
<h2 id="section-2">11/09/2019</h2>
<p>The basic routes (GET, POST) for the images are implemented and tested.<br>
We changed the database scheme: we don’t store the image directly in the DB as bytes anymore. In order to use the very convenient method <code>send_file()</code>from flask, we now store the image in the filesystem.<br>
The file are stored with a secure filename; the original filename is stored in the database along with the image URI but is not used at the moment.</p>
<p>We also have tested the features extraction via a CNN and use it to compute the distance between two images.<br>
We have a set of features vectors <span class="katex--inline"><span class="katex"><span class="katex-mathml"><math><semantics><mrow><mi>F</mi><mo>=</mo><mo stretchy="false">{</mo><msub><mi>x</mi><mn>1</mn></msub><mo separator="true">,</mo><msub><mi>x</mi><mn>2</mn></msub><mo separator="true">,</mo><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi><mi mathvariant="normal">.</mi><mo separator="true">,</mo><msub><mi>x</mi><mi>n</mi></msub><mo stretchy="false">}</mo></mrow><annotation encoding="application/x-tex">F= \{x_1, x_2, ...,x _n\}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height: 0.68333em; vertical-align: 0em;"></span><span style="margin-right: 0.13889em;" class="mord mathdefault">F</span><span class="mspace" style="margin-right: 0.277778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right: 0.277778em;"></span></span><span class="base"><span class="strut" style="height: 1em; vertical-align: -0.25em;"></span><span class="mopen">{</span><span class="mord"><span class="mord mathdefault">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.301108em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">1</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right: 0.166667em;"></span><span class="mord"><span class="mord mathdefault">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.301108em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">2</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span><span class="mpunct">,</span><span class="mspace" style="margin-right: 0.166667em;"></span><span class="mord">.</span><span class="mord">.</span><span class="mord">.</span><span class="mpunct">,</span><span class="mspace" style="margin-right: 0.166667em;"></span><span class="mord"><span class="mord mathdefault">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.151392em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathdefault mtight">n</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span><span class="mclose">}</span></span></span></span></span> with <span class="katex--inline"><span class="katex"><span class="katex-mathml"><math><semantics><mrow><mi>n</mi></mrow><annotation encoding="application/x-tex">n</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height: 0.43056em; vertical-align: 0em;"></span><span class="mord mathdefault">n</span></span></span></span></span> the number of images in our database. Let <span class="katex--inline"><span class="katex"><span class="katex-mathml"><math><semantics><mrow><mi>x</mi><mo>∉</mo><mi>F</mi></mrow><annotation encoding="application/x-tex">x \not\in F</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height: 0.88888em; vertical-align: -0.19444em;"></span><span class="mord mathdefault">x</span><span class="mspace" style="margin-right: 0.277778em;"></span><span class="mrel"><span class="mord"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.69444em;"><span class="" style="top: -3em;"><span class="pstrut" style="height: 3em;"></span><span class="rlap"><span class="strut" style="height: 0.88888em; vertical-align: -0.19444em;"></span><span class="inner"><span class="mrel"></span></span><span class="fix"></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.19444em;"><span class=""></span></span></span></span></span></span></span><span class="base"><span class="strut" style="height: 0.5782em; vertical-align: -0.0391em;"></span><span class="mrel">∈</span><span class="mspace" style="margin-right: 0.277778em;"></span></span><span class="base"><span class="strut" style="height: 0.68333em; vertical-align: 0em;"></span><span style="margin-right: 0.13889em;" class="mord mathdefault">F</span></span></span></span></span> a feature vector, the most similar image is given by its vector <span class="katex--inline"><span class="katex"><span class="katex-mathml"><math><semantics><mrow><msub><mi>x</mi><mi>i</mi></msub><mo>∈</mo><mi>F</mi></mrow><annotation encoding="application/x-tex">x_i \in F</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height: 0.6891em; vertical-align: -0.15em;"></span><span class="mord"><span class="mord mathdefault">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.311664em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathdefault mtight">i</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span><span class="mspace" style="margin-right: 0.277778em;"></span><span class="mrel">∈</span><span class="mspace" style="margin-right: 0.277778em;"></span></span><span class="base"><span class="strut" style="height: 0.68333em; vertical-align: 0em;"></span><span style="margin-right: 0.13889em;" class="mord mathdefault">F</span></span></span></span></span> minimizing the distance :<br>
<span class="katex--display"><span class="katex-display"><span class="katex"><span class="katex-mathml"><math><semantics><mrow><mi>i</mi><mo>=</mo><munder><mo><mi mathvariant="normal">arg min</mi><mo>⁡</mo></mo><mi>i</mi></munder><mo stretchy="false">∥</mo><mi>x</mi><mo>−</mo><msub><mi>x</mi><mi>i</mi></msub><msub><mo stretchy="false">∥</mo><mn>2</mn></msub></mrow><annotation encoding="application/x-tex">
i = \argmin_{i} \lVert x - x_i \rVert_2 
</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height: 0.65952em; vertical-align: 0em;"></span><span class="mord mathdefault">i</span><span class="mspace" style="margin-right: 0.277778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right: 0.277778em;"></span></span><span class="base"><span class="strut" style="height: 1.6721em; vertical-align: -0.922104em;"></span><span class="mop op-limits"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.66786em;"><span class="" style="top: -2.1779em; margin-left: 0em;"><span class="pstrut" style="height: 3em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathdefault mtight">i</span></span></span></span><span class="" style="top: -3em;"><span class="pstrut" style="height: 3em;"></span><span class=""><span class="mop"><span class="mop"><span class="mord mathrm">a</span><span class="mord mathrm">r</span><span style="margin-right: 0.01389em;" class="mord mathrm">g</span><span class="mspace" style="margin-right: 0.166667em;"></span><span class="mord mathrm">m</span><span class="mord mathrm">i</span><span class="mord mathrm">n</span></span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.922104em;"><span class=""></span></span></span></span></span><span class="mopen">∥</span><span class="mord mathdefault">x</span><span class="mspace" style="margin-right: 0.222222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right: 0.222222em;"></span></span><span class="base"><span class="strut" style="height: 1em; vertical-align: -0.25em;"></span><span class="mord"><span class="mord mathdefault">x</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.311664em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mathdefault mtight">i</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span><span class="mclose"><span class="mclose">∥</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.301108em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">2</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span></span></span></span></span></span><br>
with <span class="katex--inline"><span class="katex"><span class="katex-mathml"><math><semantics><mrow><mo stretchy="false">∥</mo><mi mathvariant="normal">.</mi><msub><mo stretchy="false">∥</mo><mn>2</mn></msub></mrow><annotation encoding="application/x-tex">\lVert.\rVert_2</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height: 1em; vertical-align: -0.25em;"></span><span class="mopen">∥</span><span class="mord">.</span><span class="mclose"><span class="mclose">∥</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.301108em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">2</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span></span></span></span></span> the <span class="katex--inline"><span class="katex"><span class="katex-mathml"><math><semantics><mrow><msub><mi>L</mi><mn>2</mn></msub></mrow><annotation encoding="application/x-tex">L_2</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height: 0.83333em; vertical-align: -0.15em;"></span><span class="mord"><span class="mord mathdefault">L</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height: 0.301108em;"><span class="" style="top: -2.55em; margin-left: 0em; margin-right: 0.05em;"><span class="pstrut" style="height: 2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight">2</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height: 0.15em;"><span class=""></span></span></span></span></span></span></span></span></span></span> the norm.<br>
We used a subset of 150 images from a collection (<a href="https://goo.gl/Lf9vmN">https://goo.gl/Lf9vmN</a>) to test the this method.<br>
We first tested using the VGG16 model to validate the method. Then we switched to MobileNetV2. It is a lightweight CNN architecture aiming for mobile, (9Mo vs 60Mo for VGG16). We get the same results with a reduced computing time.<br>
The downside is that the last layer outputs an array of 62720 elements, much higher than VGG16’s 25088 vectors size. But as an numpy array of 62k elements weights only 255 Ko once converted to bytes, the impact on storage should be small.</p>
<h2 id="section-3">12/09/2019</h2>
<p>The route for retrieving the Exif metadata is tested and implemented. We first used a python library (exifread) to extract the metada, but the return type was not serializable. So we switched to a pure PIL implementation as we will use this library for image manipulation (from <a href="https://developer.here.com/blog/getting-started-with-geocoding-exif-image-metadata-in-python3">https://developer.here.com/blog/getting-started-with-geocoding-exif-image-metadata-in-python3</a>)</p>
<p>We decided to use only PIL for the basic image manipulation (read from file, resize, convert array), thus we won’t need scikit-image. Same for scikit-learn as we use a pre-trained model for the moment.</p>
<p>The final list of libraries used (not explicit):</p>
<ul>
<li>Flask</li>
<li>Flask-RESTful</li>
<li>Flask-SQLAlchem</li>
<li>Postgres</li>
<li>Pytest</li>
<li>Pillow</li>
<li>Numpy</li>
<li>Keras w/ TF backend</li>
<li>gunicorn</li>
</ul>
<h2 id="section-4">13/09/2019</h2>
<p>We first planned to deploy a production configuration of the app on Heroku, so that it would be possible to test the app directly, but Heroku’s file storage on the free plan is ephemeral (<a href="https://help.heroku.com/K1PPS2WM/why-are-my-file-uploads-missing-deleted">https://help.heroku.com/K1PPS2WM/why-are-my-file-uploads-missing-deleted</a>).<br>
A solution would be to use Amazon S3 as an external file storage.</p>
<h2 id="section-5">14/09/2019</h2>
<p>We implemented the Keras Convolutional Neural Network model, using Tensorflow backend. We used the MobileNetV2 model, trained on ImageNet set, and changed the input layer so that it accepts image of size (224,224). The model is saved on an hdf5 file that contains the network architecture and its weights.</p>
<p>We spent some time on how to build a Docker image with Keras and Tensorflow. At first we used Alpine image with python3.7 but there is no Wheel available for scipy and h5py so they need to be compiled which makes the building time significant longer. So we switched to an Ubuntu Core image, thus we now have most python wheel compatible on a lightweight version of Ubuntu. As a result, we have a simpler Dockerfile but the image is quite big (about 780 Mo).</p>
<p>In a production context it should be interesting to use a pure Tensorflow implementation, but Keras provides a set of utility functions for data preprocessing and prediction wrapping.<br>
As an outlook using tensorflow-model-serving would make the API more flexible and modular as we would implement the neural network on a different REST API.</p>
<h2 id="section-6">15/09/2019</h2>
<p>We used Flask-admin to deploy an admin panel in order to visualize the state of the database and the files present in the upload folder.</p>
<p>We deployed the app on Heroku anyway. The stored files will be deleted eventually and the API will return an error when the file is not found. But it is still possible to send image via POST and retrieve similar image and metadata on the go.</p>
<p>Right now, the similar image is computed by querying the database all images’ features vector and return the one which minimizes the L2 distance. It is not the most efficient as we have to retrieve the vectors from the DB every time a similar image is requested.<br>
For example we could use a memory mapped tree holding the image id ans its vector. Then using an approximate nearest neighbor search algorithm should increase performance as we would only use the tree to retrieve the similar image’s id. An implementation of this kind of algorithm, and used at Spotify, is available at <a href="https://github.com/spotify/annoy">https://github.com/spotify/annoy</a>.</p>
<p>Using t-SNE projection we could also produce a 2-dimensional cluster visualization and embed it on an endpoint using D3.js.</p>

    </div>
  </div>
</body>

</html>
